
PKUNZIP (R)    FAST!    Extract Utility    Version 2.04g  02-01-93
Copr. 1989-1993 PKWARE Inc. All Rights Reserved. Shareware Version
PKUNZIP Reg. U.S. Pat. and Tm. Off.

 80486 CPU detected.
 XMS version 2.00 detected.
 DPMI version 0.90 detected.

Searching ZIP: COMMON.ZIP
  Inflating: COMMON.H  <to console>

//	This is the header file for a common module for MFC applications.
//	Currently, this module must be compiled into the project, instead of
//	linked.
//
//	If QuickWin is being used make sure that QUICK_WIN is defined for the
//	project as a whole (not just for includes), so that COMMON.CPP will
//	exclude code that would require a DLL.
//

#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <limits.h>

//	Define the types that "should" have been defined in Win16
//

#if !defined(_WIN32)
#	define CONST	const
#	define STATIC	static
#	define EXTERN	extern
#	define VOID		void
//#define BYTE unsigned char
	typedef int 	INT;
	typedef char 	CHAR;
	typedef double 	DOUBLE;
	typedef float 	FLOAT;
#	if defined(QUICK_WIN)
		typedef CHAR*			PSTR;
		typedef VOID __far* 	LPVOID;
#	endif
	typedef WORD __far* 	LPWORD;
	typedef LPSTR __far* 	LPLPSTR;
	typedef CHAR*			PCHAR;
	typedef CHAR*			PSZ;
	typedef CONST CHAR*		PCSTR;
	typedef CONST CHAR*		PCSZ;
	typedef BYTE*			PBYT;
#else
	typedef WORD * 		LPWORD;
	typedef LPSTR * 	LPLPSTR;
#endif

#if !defined(QUICK_WIN)
	typedef WNDPROC*	PWNDPROC;
#endif

#define WORD_MAX	(USHRT_MAX)
#define DWORD_MAX	(ULONG_MAX)


//	Common constants
//
CONST CHAR cNULL = '\0';
CONST CHAR cSPACE = ' ';
CONST CHAR cTAB = '\t';
CONST CHAR cCOMMA = ',';

CONST CHAR szNEW_LINE[] = "\n";
CONST CHAR szNEWLINE[] = "\n";
CONST CHAR szNULL[] = "";

CONST INT nINVALID_INDEX = -1;

CONST CStringArray asNULL;
CONST CString sNULL;

//	Helper macros
//

#define NUM_ELEMENTS(array)	(sizeof(array) / sizeof(array[0]))
#define STR_LEN(string)		(NUM_ELEMENTS(string) - 1)

#if defined(_DEBUG)
const CHAR szEQUALS[] =		" = ";
const CHAR szTERM[] =		"; ";
#define DUMPLN()		dc << szNEW_LINE;
#define DUMP_VAR(var)	dc << #var << szEQUALS << var << szTERM
#define DUMPLN_VAR(var)	DUMP_VAR(var) << szNEW_LINE;
#define DUMP_OBJ(obj)	dc << #obj << szEQUALS << &obj << szTERM
#define DUMPLN_OBJ(obj)	DUMP_OBJ(obj) << szNEW_LINE;
#endif

#if defined(_DEBUG)
EXTERN INT nTraceLevel;
#define TRACEX(nLevel, nParams)			if (nTraceLevel >= nLevel) { TRACE nParams; }
//#define AFX_DUMPX(nLevel, Variable)		if (nTraceLevel >= nLevel) AFX_DUMP1(#Variable " = ", Variable)
#define AFX_DUMPX(nLevel, Variable)		if (nTraceLevel >= nLevel) afxDump << Variable << szNEW_LINE
#else
#define TRACEX(nLevel, nParams)
#define AFX_DUMPX(nLevel, nParams)
#endif


//	Global variables
//
EXTERN CStringArray asNull;
EXTERN CString sNull;

////	Change this to an Application Class (eg, CWinAppX)
////
EXTERN CString printFile;
inline VOID SetPrintFile (CString& file)	{ printFile = file; }
inline CString& GetPrintFile (VOID)			{ return (printFile); }


//	"Type-safe" conversions
//

inline INT ToInt (LONG lValue)
{
	ASSERT((lValue >= INT_MIN) && (lValue <= INT_MAX));
	return ((INT)lValue);
}

inline INT ToInt (WORD wNum)
{
	ASSERT(wNum <= INT_MAX);
	return ((INT)wNum);
}

inline INT LongToInt (LONG lValue)
{
	TRACE("LongToInt is obsolete; use ToInt instead\n");
	return (ToInt(lValue));
}

inline INT DwordToInt (DWORD dwValue)
{
	ASSERT(dwValue <= INT_MAX);
	return ((INT)dwValue);
}

inline LONG ToLong (INT nValue)
{
	return ((LONG)nValue);
}

inline LONG IntToLong (INT nValue)
{
	TRACE("IntToLong is obsolete; use ToLong instead\n");
	return (ToLong(nValue));
}

inline DWORD IntToDword (INT nValue)
{
	ASSERT(nValue >= 0);
	return ((DWORD)nValue);
}

inline DWORD LongToDword (LONG lValue)
{
	ASSERT(lValue >= 0);
	return ((DWORD)lValue);
}

inline INT ToUInt (LONG lNum)
{
	ASSERT((0 <= lNum) && (lNum <= UINT_MAX));
	return ((UINT)lNum);
}

inline WORD ToWord (INT nNum)
{
	ASSERT((0 <= nNum) && (nNum <= WORD_MAX));
	return ((WORD)nNum);
}

inline CHAR ToChar (INT nValue)
{
	ASSERT((nValue >= CHAR_MIN) && (nValue <= CHAR_MAX));
	return ((CHAR)nValue);
}

inline CHAR ToChar (BYTE by)
{
	return ((CHAR)by);
}

//	Wrapper macros
//

#if FALSE
#define IsSpace isspace
#define StrCmp	_fstrcmp
#define ToUpper toupper
#endif

inline BOOL IsSpace (CHAR c)	{ return (isspace(c)); }
inline BOOL IsPrintable (CHAR c)	{ return (isprint(c)); }
inline BOOL IsControlChar (CHAR c)	{ return (iscntrl(c)); }
inline CHAR ToUpper (CHAR c)	{ return (ToChar(toupper(c))); }
inline CHAR ToLower (CHAR c)	{ return (ToChar(tolower(c))); }
inline INT StrCmp (PCSZ psz1, PCSZ psz2)	{ return (_fstrcmp(psz1, psz2)); }

#define	PrintToBuffer	sprintf
#define	vPrintToBuffer	vsprintf


//	Wrapper inlines
//

inline int StrNCmpI (LPCSTR str1, LPCSTR str2, INT nLen)
{
	return (_fstrnicmp(str1, str2, nLen));
}

inline VOID ZeroMem (LPVOID lpData, INT nLen)
{
	_fmemset(lpData, 0, nLen);
}

#if !defined(QUICK_WIN)
inline BOOL IsKeyPressed (INT nKey)
{
	return (::GetKeyState(nKey) < 0);
}

inline BOOL IsKeyToggled (INT nKey)
{
	return ((::GetKeyState(nKey) & 0x1) == 0x1);
}

inline BOOL IsAltPressed (VOID)		{ return (IsKeyPressed(VK_MENU)); }
inline BOOL IsShiftPressed (VOID)	{ return (IsKeyPressed(VK_SHIFT)); }
inline BOOL IsControlPressed (VOID)	{ return (IsKeyPressed(VK_CONTROL)); }
#endif


//	String extension
//
class CStringx : public CString
{
public:
// Constructors
	CStringx();
	CStringx(const CString& stringSrc);
	CStringx(char ch, int nRepeat = 1);
	CStringx(const char* psz);
	CStringx(const char* pch, int nLength);
	//	operations
public:
	INT FirstNonblank (VOID);
	INT LastNonblank (VOID);
	CStringx TrimLeading (VOID);
	CStringx TrimTrailing (VOID);
	CStringx Trim (VOID);
	CStringx RemoveComment (CHAR commentChar);
	INT SkipDelims (INT nPos, CONST CStringx& chars);
	INT FindAt (INT nPos, CHAR ch);
	INT FindAt (INT nPos, CONST CStringx& chars);
public:
	// overloaded assignment
	const CStringx& operator=(const CString& stringSrc);
	const CStringx& operator=(const CStringx& stringSrc);
	const CStringx& operator=(char ch);
	const CStringx& operator=(const char* psz);
	operator CString (VOID) { return (*(CString*)this); }
};

#if FALSE
class CStringxArray : public CObjArray
{
public:
	CStringxArray();
	VOID ~CStringxArray();
	CStringx operator[] (INT i) { 
}
#endif

//	Miscellaneous functions
//
INT StringToInt (CONST CString& text, INT& nPos);
VOID ParseCmdLine (LPCSTR lpArgs);
VOID ParseCmdLine (CONST CString& line);
VOID ParseCmdLine (PSZ apszArgv[], INT nArgc);
VOID TokenizeText (CStringArray& tokens, CONST CStringx& text, CONST CStringx& delims);
CString JoinTokens (CONST CStringArray& tokens, CHAR cSeparator = cCOMMA);
CString FilterControlChars (PCSZ pszText);
CString ExtractToken (CONST CStringx& text, INT& pos, CONST CString& delims);
CString ExtractHead (CStringx& phrase);
PSZ AccessString (CString* pstr, INT nLen);
VOID ReleaseString (CString* pstr, INT nLen = -1);
VOID SplitPath (CONST CString& filename, CString* pdrive, CString* pdir, CString* pfname, CString* pext);
CString ExtractFileBase (CONST CString& filename);
CString Blanks (INT nLen);
#if !defined(QUICK_WIN)
HWND GetMainHwnd (VOID);
CString GetTempPath (VOID);
VOID Pause (DWORD dwMilliSecs);
#endif
LONG AvailMem (VOID);
CString FormatDate (CTime& date, BOOL bEuro = FALSE);
CString FormatDate (BOOL bEuro = FALSE);
CString FormatTime (CTime& date);
CString FormatTime (VOID);
CString FormatDateTime (CTime& date, BOOL bEuro = FALSE);
CString FormatDateTime (BOOL bEuro = FALSE);


inline CString String (LONG lValue)
{
	CHAR szText[20];
	sprintf(szText, "%ld", lValue);
	return (szText);
}

inline CString String (INT nValue)
{
	CHAR szText[20];
	sprintf(szText, "%d", nValue);
	return (szText);
}

inline CString LongToString (LONG lValue)
{
	TRACE("LongToString is obsolete; use String instead\n");
	return (String(lValue));
}

inline CString IntToString (INT nValue)
{
	TRACE("IntToString is obsolete; use String instead\n");
	return (String(nValue));
}

inline CString DoubleToString (DOUBLE dValue)
{
	CHAR szText[20];
	sprintf(szText, "%g", dValue);
	return (szText);
}

inline CString FloatToString (FLOAT flValue)
{
	CHAR szText[20];
	sprintf(szText, "%g", flValue);
	return (szText);
}


//	Miscellaneous numeric operations
//

#define NORMALIZE(value, divisor)	(((value) + ((divisor) - 1)) & (0x0FFFFFFF & ~((divisor) - 1)))

//	Other stuff
//
#define MAKE_CLASS_CAST(class_name) \
	inline class_name* To##class_name (CObject* pObject) \
	{	class_name* pClassObject = (class_name*)pObject; \
		if (pClassObject) { \
			ASSERT(pClassObject->IsKindOf(RUNTIME_CLASS(class_name))); \
			ASSERT_VALID(pClassObject); \
			} \
		return (pClassObject); }

inline BOOL ValidIndex (INT nPos, CONST CObArray& array)
{
	return ((nPos >=0) && (nPos < array.GetSize()));
}

inline BOOL ValidIndex (INT nPos, CONST CStringArray& array)
{
	return ((nPos >=0) && (nPos < array.GetSize()));
}

