REM ....Build components...

set BUILD=Debug
SET FAST=false
:check_args
if (%1) == () goto end_args
if not (%1) == (-f) goto end_fast_chk
set FAST=true
shift
:end_fast_chk
if not (%1) == (-r) goto end_build_chk
set build=Release
shift
:end_build_chk
goto check_args
:end_args

if %FAST% == true goto compile
if not exist %BUILD%\. mkdir %BUILD%
if exist program.z del program.z
if exist common.z del common.z
if exist %BUILD%\program.z del %BUILD%\program.z
if exist %BUILD%\source.z del %BUILD%\source.z

REM Use this for no compression
REM SET COMPRESS_MODE=-sn

REM Use this for highest compresssion (default)
SET COMPRESS_MODE=

if not exist %BUILD%\disk1\. mkdir %BUILD%\disk1
if not exist %BUILD%\disk2\. mkdir %BUILD%\disk2

icomp %COMPRESS_MODE% ReadMe.txt %BUILD%\common.z
for %%F in (..\Info\good\sample.cwd ..\Info\good\andorra.cwd ..\Info\good\kmc*.cwd) do icomp %COMPRESS_MODE% %%F %BUILD%\common.z
for %%F in (..\Info\*.bat ..\Info\*.pe) do icomp %COMPRESS_MODE% %%F %BUILD%\common.z
for %%F in (CWord Wordz GridInfer grep) do icomp %COMPRESS_MODE% ..\bin\%BUILD%\%%F.exe %BUILD%\program.z
for %%F in (unabr.dic grepdict.bat) do icomp %COMPRESS_MODE% ..\bin\%BUILD%\%%F %BUILD%\program.z
for %%F in (Lookup MvLookup TrlLookup WnLookup GnuGPL) do icomp %COMPRESS_MODE% ..\bin\%BUILD%\%%F.dll %BUILD%\program.z
for %%F in (..\bin\%BUILD%\System\*.dll ..\bin\%BUILD%\*.bnx) do icomp %COMPRESS_MODE% %%F %BUILD%\program.z

REM Split the file into 1420KB chunks except for chunk that goes on disk 1
split -f1420 -d1@770 %BUILD%\program.z %BUILD%

REM Copy the compressed and split apart files to the distribution directories
copy %BUILD%\program.1 %BUILD%\disk1
copy %BUILD%\program.2 %BUILD%\disk2
copy %BUILD%\common.z %BUILD%\disk1
copy disk1.id %BUILD%\disk1
copy disk2.id %BUILD%\disk2
:end_compress

:compile
REM Compile the setup script and the package list
cd setup
compile setup.rul
copy setup.ins ..\%BUILD%\disk1
packlist setup_%BUILD%.lst

REM Copy the compiled scripts into the main distribution directories
copy setup.pkg ..\%BUILD%\disk1
copy _inst32i.ex_ ..\%BUILD%\disk1
cd ..
