// parsevw.h : interface of the CParserView class
//
/////////////////////////////////////////////////////////////////////////////

class CParserView : public CFormView
{
protected: // create from serialization only
	CParserView();
	DECLARE_DYNCREATE(CParserView)

public:
	//{{AFX_DATA(CParserView)
	enum { IDD = IDD_PARSER_FORM };
	CButton	m_btnParseIt;
	CString	m_sGraphName;
	CString	m_sLexiconName;
	CString	m_sPhrase;
	CString	m_sResults;
	//}}AFX_DATA

// Attributes
public:
	CParserDoc* GetDocument();

// Operations
public:

// Implementation
private:
	CParseManager* m_pParseMan;
	CString m_sPrevGraph;
	CString m_sPrevLexicon;
public:
	virtual ~CParserView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Generated message map functions
protected:
	//{{AFX_MSG(CParserView)
	afx_msg void OnParseIt();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

MAKE_CLASS_CAST(CParserView)

#if !defined(_DEBUG)  // debug version in parsevw.cpp
inline CParserDoc* CParserView::GetDocument (VOID)
   { return (ToCParserDoc(m_pDocument)); }
#endif

/////////////////////////////////////////////////////////////////////////////
