/*
	ic.h - interclient communication dealing with escort, wordnet, and
		   context

	Uses cut buffers 2-7
*/

#define WORDNET		5
#define ESCORT		6
#define CONTEXT		7

#define MAXNUM		32

#define ALL		-1

#define WAITING		4

#define DELN		"/^\\"

typedef struct Packet_info {
	short from;
	short to;
	char *word;
	int num;
	int senses[MAXNUM];
	int pos[MAXNUM];
	char *extra;
} Packet, *Packet_p;

int app_type;

void InitializeCommunication();
void SendPacket();
Packet_p ReceivePacket();
void PickUpLine();
void HangUpLine();
void SetTimer();
