static void ErrorOut (char* pszFormat, ...)
{
    static char szText[256];

    // format the trace text
    va_list vaArgs;
    va_start (vaArgs, pszFormat);
    int nLen = vsprintf(szText, pszFormat, vaArgs);
    va_end (vaArgs);    

    // display it
#if defined(_WINDOWS)
    OutputDebugText(szText);
#else
    fprintf(stderr, szText);
#endif
}
