// GridInfer.h : main header file for the GridInfer application
//
// This is an adaptation of the DIBLOOK source from the Microsoft MFC SDK:
//
//		This is a part of the Microsoft Foundation Classes C++ library.
//		Copyright (C) 1992 Microsoft Corporation
//		All rights reserved.
//
//		This source code is only intended as a supplement to the
//		Microsoft Foundation Classes Reference and Microsoft
//		QuickHelp and/or WinHelp documentation provided with the library.
//		See these sources for detailed information regarding the
//		Microsoft Foundation Classes product.
//

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"           // main symbols

#define WM_DOREALIZE   (WM_USER + 0)

/////////////////////////////////////////////////////////////////////////////
// CGridInferApp:
// See GridInfer.cpp for the implementation of this class
//

class CGridInferApp : public CWinApp
{
public:
	CGridInferApp();

// Overrides
	virtual BOOL InitInstance();
	CString ParseCmdLine (VOID);

// Implementation
	CString m_sFile;
	BOOL m_bBatchMode;
	BOOL m_bLaunchedEmbedded;

	//{{AFX_MSG(CGridInferApp)
	afx_msg void OnAppAbout();
	afx_msg void OnFileOpen();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////
