#include <stdio.h>
#include <stdarg.h>
#if defined(_WINDOWS)
#include <windows.h>
#endif

void DisplayError (char* pszFormat, ...)
{
    static char szText[256];

    // format the trace text
    va_list vaArgs;
    va_start (vaArgs, pszFormat);
    vsprintf(szText, pszFormat, vaArgs);
    va_end (vaArgs);    

    // display it
#if defined(_NORMAL)
    fprintf(stderr, szText);
#else
    OutputDebugString("WordNet: ");
    OutputDebugString(szText);
#endif
}
